//+------------------------------------------------------------------+
//|                                            LabTrend1_v5 600+.mq4 |
//|                             Copyright  2008-14, TrendLaboratory |
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |
//|                                   E-mail: igorad2003@yahoo.co.uk |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008-14, TrendLaboratory"
#property link      "http://finance.groups.yahoo.com/group/TrendLaboratory"

#property indicator_chart_window
#property indicator_buffers   4
#property indicator_color1 DodgerBlue
#property indicator_color2 OrangeRed
#property indicator_width1 1
#property indicator_width2 1
#property indicator_color3 DodgerBlue
#property indicator_color4 OrangeRed
#property indicator_width3 3
#property indicator_width4 3

//---- indicator parameters

extern int     TimeFrame         =     0;    // TimeFrame in min
extern double  Risk              =     3;    // Price Channel narrowing factor (1..10)  
extern int     SignalMode        =     1;    // Switch of Signal mode(0-off,1-on)
extern int     ColorBarsMode     =     1;    // Switch of Color Bars mode(0-off,1-on)

extern string  alerts            = "--- Alerts & Emails ---";
extern int     AlertMode         =     0;
extern int     SoundsNumber      =     5;    // Number of sounds after Signal
extern int     SoundsPause       =     5;    // Pause in sec between sounds 
extern string  UpSound           = "alert.wav";
extern string  DnSound           = "alert2.wav";
extern int     EmailMode         =     0;    // 0-on,1-off   
extern int     EmailsNumber      =     1;    // 0-on,1-off
                                          

//---- indicator buffers
double upSignal[];
double dnSignal[];
double upTrend[];
double dnTrend[];
double trend[];
double upband[];
double dnband[];
//----

int    Length, draw_begin;
string TF, IndicatorName, short_name, prevmess, prevemail;
double  _point;
datetime ptime, preTime;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   if(TimeFrame <= Period()) TimeFrame = Period();
   TF = tf(TimeFrame);
   if(TF  == "Unknown timeframe") TimeFrame = Period();
   
   IndicatorDigits(Digits);

//---- indicator buffers mapping
   IndicatorBuffers(7);
   SetIndexBuffer(0,upSignal); SetIndexStyle(0,    DRAW_ARROW); SetIndexArrow(0,108);
   SetIndexBuffer(1,dnSignal); SetIndexStyle(1,    DRAW_ARROW); SetIndexArrow(1,108);
   SetIndexBuffer(2, upTrend); SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3, dnTrend); SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(4,   trend);
   SetIndexBuffer(5,  upband);
   SetIndexBuffer(6,  dnband);
           
//---- indicator name
     
   IndicatorName = WindowExpertName(); 
   
   short_name =  "[" + TF + "]("+ DoubleToStr(Risk,2) + "," + SignalMode + "," + SignalMode + ")";
   
   IndicatorShortName(IndicatorName + short_name);
           
   SetIndexLabel(0,"LabTrend1 UpSignal");
   SetIndexLabel(1,"LabTrend1 DnSignal");
   SetIndexLabel(2,"LabTrend1 UpTrend");
   SetIndexLabel(3,"LabTrend1 DnTrend");     
   
   Length = 3 + 2*Risk;
   
   draw_begin = Bars - iBars(NULL,TimeFrame)*TimeFrame/Period() + Length;
      
   SetIndexDrawBegin(0,draw_begin);
   SetIndexDrawBegin(1,draw_begin);
   SetIndexDrawBegin(2,draw_begin);
   SetIndexDrawBegin(3,draw_begin);
//----
   
   _point   = Point*MathPow(10,Digits%2);
//---- initialization done
   
   return(0);
}

int deinit() {Comment(""); return(0);}

//+------------------------------------------------------------------+
//| LabTrend1_v5 600+                                                |
//+------------------------------------------------------------------+
int start()
{
   int limit, i, shift, counted_bars = IndicatorCounted(); 
   
   
   if(counted_bars > 0) limit = Bars - counted_bars - 1;
   if(counted_bars < 0) return(0);
   if(counted_bars < 1)
   { 
   limit = Bars-1;   
      for(i=limit;i>=0;i--) 
      {
      upSignal[i] = EMPTY_VALUE; 
      dnSignal[i] = EMPTY_VALUE; 
      upTrend[i]  = EMPTY_VALUE; 
      dnTrend[i]  = EMPTY_VALUE;
      }
   }   
   
   if(TimeFrame != Period())
	{
   limit = MathMax(limit,TimeFrame/Period());   
      
      for(shift = 0;shift < limit;shift++) 
      {	
      int y = iBarShift(NULL,TimeFrame,Time[shift]);
      
         if(SignalMode > 0)
         {
         upSignal[shift] = iCustom(NULL,TimeFrame,IndicatorName,0,Risk,SignalMode,ColorBarsMode,"",AlertMode,SoundsNumber,SoundsPause,UpSound,DnSound,EmailMode,EmailsNumber,0,y);      
         dnSignal[shift] = iCustom(NULL,TimeFrame,IndicatorName,0,Risk,SignalMode,ColorBarsMode,"",AlertMode,SoundsNumber,SoundsPause,UpSound,DnSound,EmailMode,EmailsNumber,1,y);      
         }
      
         if(ColorBarsMode > 0)
         {         
         trend[shift]   = iCustom(NULL,TimeFrame,IndicatorName,0,Risk,SignalMode,ColorBarsMode,"",AlertMode,SoundsNumber,SoundsPause,UpSound,DnSound,EmailMode,EmailsNumber,4,y);      
         upband[shift]  = iCustom(NULL,TimeFrame,IndicatorName,0,Risk,SignalMode,ColorBarsMode,"",AlertMode,SoundsNumber,SoundsPause,UpSound,DnSound,EmailMode,EmailsNumber,5,y);      
         dnband[shift]  = iCustom(NULL,TimeFrame,IndicatorName,0,Risk,SignalMode,ColorBarsMode,"",AlertMode,SoundsNumber,SoundsPause,UpSound,DnSound,EmailMode,EmailsNumber,6,y);      
         
         upTrend[shift]  = EMPTY_VALUE;
         dnTrend[shift]  = EMPTY_VALUE;    
         
            if(trend[shift] > 0 && Close[shift] > upband[shift]) 
            {
            upTrend[shift] = MathMax(Open[shift],Close[shift]);
            dnTrend[shift] = MathMin(Open[shift],Close[shift]);
            }   
            else
            if(trend[shift] < 0 && Close[shift] < dnband[shift]) 
            {
            upTrend[shift] = MathMin(Open[shift],Close[shift]);
            dnTrend[shift] = MathMax(Open[shift],Close[shift]);
            }  
         }
      }  
	
	return(0);
	}
	else _labTrend1(limit);

   return(0);
}


//-----
void _labTrend1(int limit)
{   
   for(int shift=limit;shift>=0;shift--) 
   {
   double lomin = iLow (NULL,0,iLowest (NULL,0,MODE_LOW ,Length,shift));         
   double himax = iHigh(NULL,0,iHighest(NULL,0,MODE_HIGH,Length,shift)); 

   double diff  = himax - lomin;
   double ratio = (33 - Risk)/100;
      
   upband[shift] = himax - diff*ratio;
   dnband[shift] = lomin + diff*ratio;         
   
   
   trend[shift] = trend[shift+1];
   
   if(Close[shift] > upband[shift]) trend[shift] = 1;
   if(Close[shift] < dnband[shift]) trend[shift] =-1;
      
   upSignal[shift] = EMPTY_VALUE;
   dnSignal[shift] = EMPTY_VALUE;
   upTrend[shift]  = EMPTY_VALUE;
   dnTrend[shift]  = EMPTY_VALUE;
      
   double delta  = 0.5*iATR(NULL,0,10,shift);
            
      if(trend[shift] > 0)
      {
      if(SignalMode > 0 && trend[shift+1] < 0) upSignal[shift] = Low[shift] - delta;
         if(ColorBarsMode > 0 && Close[shift] > upband[shift]) 
         {
         upTrend[shift] = MathMax(Open[shift],Close[shift]);
         dnTrend[shift] = MathMin(Open[shift],Close[shift]);
         }    
      }   
      else
      if(trend[shift] < 0)
      {
      if(SignalMode > 0 && trend[shift+1] > 0) dnSignal[shift] = High[shift] + delta;
         if(ColorBarsMode > 0 && Close[shift] < dnband[shift]) 
         {
         upTrend[shift] = MathMin(Open[shift],Close[shift]);
         dnTrend[shift] = MathMax(Open[shift],Close[shift]);
         }   
      }   
   }
   
   if(AlertMode > 0)
   {
   bool uptrend = trend[1] > 0 && trend[2] <= 0;                  
   bool dntrend = trend[1] < 0 && trend[2] >= 0;
        
      if(uptrend || dntrend)
      {
         if(isNewBar(TimeFrame))
         {
         BoxAlert(uptrend," : BUY Signal at " +DoubleToStr(Close[1],Digits)+", StopLoss at "+DoubleToStr(upSignal[1],Digits));   
         BoxAlert(dntrend," : SELL Signal at "+DoubleToStr(Close[1],Digits)+", StopLoss at "+DoubleToStr(dnSignal[1],Digits)); 
         }
      
      WarningSound(uptrend,SoundsNumber,SoundsPause,UpSound,Time[1]);
      WarningSound(dntrend,SoundsNumber,SoundsPause,DnSound,Time[1]);
         
         if(EmailMode > 0)
         {
         EmailAlert(uptrend,"BUY" ," : BUY Signal at " +DoubleToStr(Close[1],Digits)+", StopLoss at "+DoubleToStr(upSignal[1],Digits),EmailsNumber); 
         EmailAlert(dntrend,"SELL"," : SELL Signal at "+DoubleToStr(Close[1],Digits)+", StopLoss at "+DoubleToStr(dnSignal[1],Digits),EmailsNumber); 
         }
      }
   }
}


//-----

bool isNewBar(int tf)
{
   static datetime pTime;
   bool res=false;
   
   if(tf >= 0)
   {
      if (iTime(NULL,tf,0)!= pTime)
      {
      res=true;
      pTime=iTime(NULL,tf,0);
      }   
   }
   else res = true;
   
   return(res);
}

bool BoxAlert(bool cond,string text)   
{      
   string mess = IndicatorName + "("+Symbol()+","+TF + ")" + text;
   
   if (cond && mess != prevmess)
	{
	Alert (mess);
	prevmess = mess; 
	return(true);
	} 
  
   return(false);  
}

bool Pause(int sec)
{
   if(TimeCurrent() >= preTime + sec) {preTime = TimeCurrent(); return(true);}
   
   return(false);
}

void WarningSound(bool cond,int num,int sec,string sound,datetime ctime)
{
   static int i;
   
   if(cond)
   {
   if(ctime != ptime) i = 0; 
   if(i < num && Pause(sec)) {PlaySound(sound); ptime = ctime; i++;}       	
   }
}

bool EmailAlert(bool cond,string text1,string text2,int num)   
{      
   string subj = "New " + text1 +" Signal from " + IndicatorName + "!!!";    
   string mess = IndicatorName + "("+Symbol()+","+TF + ")" + text2;
   
   if (cond && mess != prevemail)
	{
	if(subj != "" && mess != "") for(int i=0;i<num;i++) SendMail(subj, mess);  
	prevemail = mess; 
	return(true);
	} 
  
   return(false);  
}	         
 
string tf(int timeframe)
{
   switch(timeframe)
   {
   case PERIOD_M1:   return("M1");
   case PERIOD_M5:   return("M5");
   case PERIOD_M15:  return("M15");
   case PERIOD_M30:  return("M30");
   case PERIOD_H1:   return("H1");
   case PERIOD_H4:   return("H4");
   case PERIOD_D1:   return("D1");
   case PERIOD_W1:   return("W1");
   case PERIOD_MN1:  return("MN1");
   default:          return("Unknown timeframe");
   }
}                  