//+------------------------------------------------------------------+
//|                                          MaksiGen_Range_Move.mq4 |
//|                MaksiGen - MT3 by OlegVS ( olegvs2003@yahoo.com ) |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "MaksiGen - MT3 by OlegVS ( olegvs2003@yahoo.com )"
#property link      ""

#property indicator_chart_window
//---- input parameters
extern int Pfast=5;
extern int Pslow=8;
extern double K_RangeOpen=1.4;
extern int timeFrame=0;
extern string UniqueID="MaksiGen1";
extern color  HiColor1 = Silver;
extern color  LoColor1 = Silver;
extern color  HiColor2 = Silver;
extern color  LoColor2 = Silver;
extern color  Bar1Color = OliveDrab;
extern color  BarFastColor = LightSkyBlue;
extern color  BarSlowColor = Blue;
extern color  TrendHighColor = Gold;
extern color  TrendLowColor = Gold;
extern color  SellStopColor = Red;
extern color  BuyStopColor = Blue;
double hi1,lo1,hi2,lo2,Range;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
  if (timeFrame!=0) 
      if (timeFrame<Period()) timeFrame = Period();
//---- Object
ObjectCreate(UniqueID+"hi1",OBJ_HLINE,0,0,0,0,0,0,0); ObjectSet(UniqueID+"hi1",OBJPROP_COLOR,HiColor1); ObjectSet(UniqueID+"hi1",OBJPROP_STYLE,STYLE_DOT);
ObjectCreate(UniqueID+"lo1",OBJ_HLINE,0,0,0,0,0,0,0); ObjectSet(UniqueID+"lo1",OBJPROP_COLOR,LoColor1); ObjectSet(UniqueID+"lo1",OBJPROP_STYLE,STYLE_DOT);
ObjectCreate(UniqueID+"hi2",OBJ_HLINE,0,0,0,0,0,0,0); ObjectSet(UniqueID+"hi2",OBJPROP_COLOR,HiColor2); ObjectSet(UniqueID+"hi2",OBJPROP_STYLE,STYLE_DASH);
ObjectCreate(UniqueID+"lo2",OBJ_HLINE,0,0,0,0,0,0,0); ObjectSet(UniqueID+"lo2",OBJPROP_COLOR,LoColor2); ObjectSet(UniqueID+"lo2",OBJPROP_STYLE,STYLE_DASH);

ObjectCreate(UniqueID+"Bar#1",    OBJ_VLINE,0,0,0,0,0,0,0); ObjectSet(UniqueID+"Bar#1",    OBJPROP_COLOR,Bar1Color);    ObjectSet(UniqueID+"Bar#1",    OBJPROP_STYLE,STYLE_DOT);
ObjectCreate(UniqueID+"Bar#Pfast",OBJ_VLINE,0,0,0,0,0,0,0); ObjectSet(UniqueID+"Bar#Pfast",OBJPROP_COLOR,BarFastColor); ObjectSet(UniqueID+"Bar#Pfast",OBJPROP_STYLE,STYLE_DOT);
ObjectCreate(UniqueID+"Bar#Pslow",OBJ_VLINE,0,0,0,0,0,0,0); ObjectSet(UniqueID+"Bar#Pslow",OBJPROP_COLOR,BarSlowColor);         ObjectSet(UniqueID+"Bar#Pslow",OBJPROP_STYLE,STYLE_DOT);

ObjectCreate(UniqueID+"TrendHIGH",OBJ_TREND,0,0,0,0,0,0); ObjectSet(UniqueID+"TrendHIGH",OBJPROP_COLOR,TrendHighColor); ObjectSet(UniqueID+"TrendHIGH",OBJPROP_STYLE,STYLE_SOLID);
ObjectCreate(UniqueID+"Trend_LOW",OBJ_TREND,0,0,0,0,0,0); ObjectSet(UniqueID+"Trend_LOW",OBJPROP_COLOR,TrendLowColor); ObjectSet(UniqueID+"Trend_LOW",OBJPROP_STYLE,STYLE_SOLID);

ObjectCreate(UniqueID+"SELLSTOP",OBJ_HLINE,0,0,0,0,0,0,0); ObjectSet(UniqueID+"SELLSTOP",OBJPROP_COLOR,SellStopColor);  ObjectSet(UniqueID+"SELLSTOP",OBJPROP_STYLE,STYLE_DOT);
ObjectCreate(UniqueID+"BUY_STOP",OBJ_HLINE,0,0,0,0,0,0,0); ObjectSet(UniqueID+"BUY_STOP",OBJPROP_COLOR,BuyStopColor); ObjectSet(UniqueID+"BUY_STOP",OBJPROP_STYLE,STYLE_DOT);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
ObjectDelete(UniqueID+"hi1"); ObjectDelete(UniqueID+"lo1");
ObjectDelete(UniqueID+"hi2"); ObjectDelete(UniqueID+"lo2");
ObjectDelete(UniqueID+"Bar#1"); ObjectDelete(UniqueID+"Bar#Pfast"); ObjectDelete(UniqueID+"Bar#Pslow");
ObjectDelete(UniqueID+"TrendHIGH"); ObjectDelete(UniqueID+"Trend_LOW");
ObjectDelete(UniqueID+"SELLSTOP"); ObjectDelete(UniqueID+"BUY_STOP");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
//---- 
hi1=iHigh(NULL,timeFrame,iHighest(Symbol(),timeFrame,MODE_HIGH,Pfast,1));
lo1=iLow(NULL,timeFrame,iLowest(Symbol(),timeFrame,MODE_LOW,Pfast,1));
hi2=iHigh(NULL,timeFrame,iHighest(Symbol(),timeFrame,MODE_HIGH,Pslow,1));
lo2=iLow(NULL,timeFrame,iLowest(Symbol(),timeFrame,MODE_LOW,Pslow,1));
//---- horizontal lines
ObjectMove(UniqueID+"hi1",0,iTime(NULL,timeFrame,Pfast-1),hi1);
ObjectMove(UniqueID+"lo1",0,iTime(NULL,timeFrame,Pfast-1),lo1);
ObjectMove(UniqueID+"hi2",0,iTime(NULL,timeFrame,Pslow-1),hi2);
ObjectMove(UniqueID+"lo2",0,iTime(NULL,timeFrame,Pslow-1),lo2);
//---- vertical lines
ObjectMove(UniqueID+"Bar#1",    0,iTime(NULL,timeFrame,1),    iHigh(NULL,timeFrame,1));
ObjectMove(UniqueID+"Bar#Pfast",0,iTime(NULL,timeFrame,Pfast),iHigh(NULL,timeFrame,1));
ObjectMove(UniqueID+"Bar#Pslow",0,iTime(NULL,timeFrame,Pslow),iHigh(NULL,timeFrame,1));
//---- trend lines
ObjectSet(UniqueID+"TrendHIGH",OBJPROP_TIME1,iTime(NULL,timeFrame,Pslow)); ObjectSet(UniqueID+"TrendHIGH",OBJPROP_PRICE1,hi2);
ObjectSet(UniqueID+"TrendHIGH",OBJPROP_TIME2,iTime(NULL,timeFrame,Pfast)); ObjectSet(UniqueID+"TrendHIGH",OBJPROP_PRICE2,hi1);

ObjectSet(UniqueID+"Trend_LOW",OBJPROP_TIME1,iTime(NULL,timeFrame,Pslow)); ObjectSet(UniqueID+"Trend_LOW",OBJPROP_PRICE1,lo2);
ObjectSet(UniqueID+"Trend_LOW",OBJPROP_TIME2,iTime(NULL,timeFrame,Pfast)); ObjectSet(UniqueID+"Trend_LOW",OBJPROP_PRICE2,lo1);

if (hi1-lo1==hi2-lo2)
{
Range=(hi1-lo1)*K_RangeOpen;
ObjectMove(UniqueID+"SELLSTOP",0,iTime(NULL,timeFrame,Pfast-1),lo1-Range);
ObjectMove(UniqueID+"BUY_STOP",0,iTime(NULL,timeFrame,Pfast-1),hi1+Range);

ObjectSet(UniqueID+"TrendHIGH",OBJPROP_TIME1,iTime(NULL,timeFrame,Pslow-1)); ObjectSet(UniqueID+"TrendHIGH",OBJPROP_PRICE1,hi2);
ObjectSet(UniqueID+"TrendHIGH",OBJPROP_TIME2,iTime(NULL,timeFrame,Pfast-1)); ObjectSet(UniqueID+"TrendHIGH",OBJPROP_PRICE2,hi1);

ObjectSet(UniqueID+"Trend_LOW",OBJPROP_TIME1,iTime(NULL,timeFrame,Pslow)-1); ObjectSet(UniqueID+"Trend_LOW",OBJPROP_PRICE1,lo2);
ObjectSet(UniqueID+"Trend_LOW",OBJPROP_TIME2,iTime(NULL,timeFrame,Pfast)-1); ObjectSet(UniqueID+"Trend_LOW",OBJPROP_PRICE2,lo1);
}

ObjectsRedraw();

return(0);
}
//+------------------------------------------------------------------+

